// // //
// GetInfos Tracker Add-On for BeOS R5
// -----------------------------------
// This Add-On show infos of selected files/folders
//
// Autor: Didier Bertrand aka Didix ;o)
// Date : August the 17th 2001
// Latest UpDate:  21-10-2001
// // //

#include <Application.h>
#include <InterfaceKit.h>
#include <StorageKit.h>
#include <stdio.h>
#include <string.h>
#include <be/add-ons/tracker/TrackerAddon.h>


#include "InfoWindow.h"
// My special BView Class with bi-coloured background and icon
#include "InfoView.h"
#include "Recursive_explorer.h"


// // //
// Add-On function
// // //
void process_refs(entry_ref dir_ref, BMessage *msg, void *)
{
   // status of thread
   status_t status;

   // Window position & size
   BRect winrect(75,75,385,240);
   
   // Look of the window   BWindow
   InfoWindow  *window = new InfoWindow ( winrect, "GetInfos", B_TITLED_WINDOW, B_NOT_ZOOMABLE|B_NOT_RESIZABLE, B_CURRENT_WORKSPACE);

   // infoview: special bi-colored background BView
   InfoView *infoview = new InfoView( window->Bounds() );

   // Attach the view to the window
   window->AddChild( infoview );

   // Show the window
   window->Show();

   // Show "Path:"
   BStringView *PathString = new BStringView( BRect( 32,45,105,65 ), "pathlabel", "Path:", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   PathString->SetAlignment( B_ALIGN_RIGHT );
   infoview->AddChild( PathString );

   // "Folders:"
   BStringView *FolderString = new BStringView( BRect( 32,65,105,85 ), "folderslabel", "Folders:", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   FolderString->SetAlignment( B_ALIGN_RIGHT );
   infoview->AddChild( FolderString );

   // "Files:"
   BStringView *FileString = new BStringView( BRect( 32,85,105,105 ), "fileslabel", "Files:", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   FileString->SetAlignment( B_ALIGN_RIGHT );
   infoview->AddChild( FileString );

   // "Symlinks:"
   BStringView *SymlinksString = new BStringView( BRect( 32,105,105,125 ), "symlinkslabel", "Symlinks:", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   SymlinksString->SetAlignment( B_ALIGN_RIGHT );
   infoview->AddChild( SymlinksString );

   // "Total Size:"
   BStringView *TSizeString = new BStringView( BRect( 32,125,105,145 ), "totalsizelabel", "Total Size:", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   TSizeString->SetAlignment(B_ALIGN_RIGHT);
   infoview->AddChild( TSizeString );

   // Get the current path
   BPath start_path;
   BEntry start_entry( &dir_ref );
   start_entry.GetPath( &start_path );

   // Show the current path
   BStringView *the_start_path = new BStringView( BRect( 105,45,310,65 ), "pathstring", start_path.Path(), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
   infoview->AddChild( the_start_path );



   // others var
   int index;
   int nb_folders = 0;
   int nb_files = 0;
   int nb_symlinks = 0;
   off_t size = 0;
   
   char nb_folders_string[31];
   char nb_files_string[31];
   char nb_symlinks_string[31];
   char t_size_string[71];
   
   entry_ref entry_reference;
   BEntry    selected_entry;

   // Loop on entries. (selected files and folders)
   for( index = 0; msg->FindRef( "refs", index, &entry_reference ) == B_NO_ERROR; index++ )
   {
      // From an entry_ref to a BEntry
      selected_entry.SetTo( &entry_reference, false );

      // Try the validity of the entry
      if( selected_entry.Exists() )
      {
         // add the size of all sub-entries
         size += recursive_explorer( selected_entry, &nb_folders, &nb_files, &nb_symlinks );
      }
   }


   // If no files/folders are selected
   if( index == 0 )
   {
      BStringView *noselection = new BStringView( BRect( 105,15,310,35 ), "noselection", "[No Files Selected]", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
      infoview->AddChild( noselection );
   }

   // Show the number of folders
   sprintf( nb_folders_string, "%d", nb_folders );
   BStringView *nb_folders_selected = new BStringView( BRect( 105,65,310,85 ), "foldersselected", nb_folders_string, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
   infoview->AddChild( nb_folders_selected );

   // Show the number of files
   sprintf( nb_files_string, "%d", nb_files );
   BStringView *nb_files_selected = new BStringView( BRect( 105,85,310,105 ), "filesselected", nb_files_string, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
   infoview->AddChild( nb_files_selected );

   // Show the number of symlinks
   sprintf( nb_symlinks_string, "%d", nb_symlinks );
   BStringView *nb_symlinks_selected = new BStringView( BRect( 105,105,310,125 ), "symlinksselected", nb_symlinks_string, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
   infoview->AddChild( nb_symlinks_selected );

   // Show the total size of the selection
   if( size < 1024 )
   {  // size in Bytes
      sprintf( t_size_string, "%d Bytes", ( unsigned int)size );
   }
   else
   {
      if( size < 1024*1024 )
      {  // size in KBytes
         sprintf( t_size_string, "%.0f KBytes (%d Bytes)", (float)size/1024, (unsigned int)size );
      }
      else
      {
         if( size < 1024*1024*1024 )
         {  // size in MBytes
            sprintf( t_size_string, "%.1f MBytes (%d Bytes)", (float)size/(1024*1024), (unsigned int)size );
         }
         else
         {  // size in GBytes
            sprintf( t_size_string, "%.2f GBytes (%d Bytes)", (float)size/(1024*1024*1024), (unsigned int)size );
         }
      }
   }

   // show the size
   BStringView *total_size_selection = new BStringView( BRect( 105,125,310,145 ), "totalsizeselection", t_size_string, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
   infoview->AddChild( total_size_selection );

   // Wait for deleting the thread
   wait_for_thread(window->Thread(), &status);

}


// // //
// BAlert: when launching this Add-On like an executable
// // //
int main()
{
   BApplication *GetInfos_app = new BApplication("application/x-vnd.didix.GetInfos");
   BAlert *GetInfos_alert = new BAlert("","This is a Tracker Add-On.\n\nMove it to:\n /boot/home/config/add-ons/Tracker/","Oops");
   GetInfos_alert->Go();
   delete GetInfos_alert;
   delete GetInfos_app;
   return (0);
}
