//
// Recursive_exploreur.cpp
//
// GetInfos Project
//

#include "Recursive_explorer.h"

off_t recursive_explorer( BEntry current_entry, int *nb_folders, int *nb_files, int *nb_symlinks )
{
   // tempo size of files
   off_t file_size = 0;
   off_t total_size = 0;
   
   BDirectory current_directory;
   BEntry next_entry;

   if( current_entry.IsDirectory() )
   {
      *nb_folders += 1;
      current_directory.SetTo( &current_entry );
      current_directory.GetSize( &file_size );
      total_size += file_size;
      
      while( current_directory.GetNextEntry( &next_entry, false ) == B_NO_ERROR )
      {
         total_size += recursive_explorer( next_entry, nb_folders, nb_files, nb_symlinks );
      }
   }
   
   if( current_entry.IsFile() )
   {
      *nb_files += 1;
      BFile current_file( &current_entry, B_READ_ONLY );
      current_file.GetSize( &file_size );
      total_size += file_size;
   }
   
   if( current_entry.IsSymLink() )
   {
      *nb_symlinks += 1;
      BSymLink current_link( &current_entry );
      current_link.GetSize( &file_size );
      total_size += file_size;
   }

   return( total_size );

}

